bl_info = {
    "name" : "Partybots converter",
    "author" : "vuyghu2020",
    "version" : (0, 2),
    "blender" : (4, 2, 0),
    "location" : "View3d > Tool",
    "warning" : "",
    "wiki_url" : "",
    "category" : "Partybots map builder",
}

import bpy
import math
import mathutils

def clamp(x, minimum, maximum):
    return max(minimum, min(x, maximum))



def create_symbol(symbol, radius):
    if symbol == "circle":
        bpy.ops.mesh.primitive_cylinder_add(scale=(radius/2, radius/2, 40))
    elif symbol == "square":
        bpy.ops.mesh.primitive_cube_add(size=1, scale=(radius, radius, 40))
    elif symbol == "rectangle":
        bpy.ops.mesh.primitive_cube_add(size=1, scale=(radius/2, radius, 40))
    elif symbol ==  "diamond":
        bpy.ops.mesh.primitive_cylinder_add(vertices=4, scale=(radius/2, radius/2, 40))
    elif symbol == "hexagon":
        bpy.ops.mesh.primitive_cylinder_add(vertices=6, scale=(radius/2, radius/2, 40))
    elif symbol == "plus":
        
        bpy.ops.mesh.primitive_cube_add(size=1, scale=(radius/3, radius, 40))
        rect1 = bpy.context.object
        bpy.ops.mesh.primitive_cube_add(size=1)
        rect2 = bpy.context.object
        rect2.scale = (radius, radius/3, 40)
        bpy.ops.object.select_all(action='DESELECT')
        
        rect1.select_set(True)
        rect2.select_set(True)
        
        
    elif symbol == "star":
        return False
    
    
    
    elif symbol == "heart":
        return False
    
    
    
    elif symbol == "ring":
        bpy.ops.mesh.primitive_cylinder_add(radius=0.5, depth=1)
        cylinder1 = bpy.context.object
        cylinder1.scale = (radius, radius, 40)
        
        bpy.ops.mesh.primitive_cylinder_add(radius=0.3088135, depth=1)
        cylinder2 = bpy.context.object
        cylinder2.scale = (radius, radius, 41)
        bpy.ops.object.select_all(action='DESELECT')
        
        cylinder1.select_set(True)
        cylinder2.select_set(True)
    else:
        return False
    
        
    
    return True
        
    




def get_property(obj, prop_name, default_value=None):
    return obj.get(prop_name, default_value)






def add_platform(Location=mathutils.Vector((0.0, 0.25, 0.0)), Rotation=mathutils.Vector((0.0, 0.0, 0.0)), PlatformSize=6.1, VerticalPlatformSize=0.5, type="grass", conveyor=False, conveyor_velocity=0.5, conveyor_angle=-180, corner_cut=False, corner_cut_radius=5.8, corner_cut_shapes="none", hole=False, hole_radius=4, hole_shapes="none"):
    
    
    bpy.ops.mesh.primitive_cube_add(size=1)
        
    
        
    obj = bpy.context.object


        
    TEMP = Location.y
    Location.y = Location.z
    Location.z = TEMP
    
    

        
    obj.location = Location
    obj.rotation_euler = [grader * (math.pi / 180) for grader in Rotation]
    obj.scale = (PlatformSize, PlatformSize, VerticalPlatformSize)
    obj["type"] = type
    obj["conveyor"] = conveyor
    obj["conveyor_velocity"] = round(conveyor_velocity, 3)
    obj["conveyor_angle"] = round(conveyor_angle, 3)
    obj["corner_cut"] = corner_cut
    obj["corner_cut_radius"] = round(corner_cut_radius, 3)
    obj["corner_cut_shapes"] = corner_cut_shapes
    obj["hole"] = hole
    obj["hole_radius"] = round(hole_radius, 3)
    obj["hole_shapes"] = hole_shapes
        
    
    if obj["corner_cut"] and PlatformSize >= 1 :
            
            

        if create_symbol(obj["corner_cut_shapes"], (round(obj["corner_cut_radius"],3) / 7.2) * round(PlatformSize, 3)):
            
                
            cobje = bpy.context.selected_objects
                
            if obj["corner_cut_shapes"] == "ring":
                    
                cobj = cobje[0]
                cobj.location = obj.location
                cobj.rotation_euler = obj.rotation_euler
                    
                bool_mod = cobje[0].modifiers.new(name='Boolean', type='BOOLEAN')
                    
                bool_mod.object = cobje[1]
                    
                cobje[1].select_set(False)
                bpy.context.view_layer.objects.active = cobje[0]
                cobje[0].select_set(True)
                bpy.ops.object.modifier_apply(modifier=bool_mod.name)
                bpy.data.objects.remove(cobje[1], do_unlink=True)
                    
                    
                for key in obj.keys():
                    if key != "_RNA_UI":
                        cobje[0][key] = obj[key]

#                cobje[0].scale.z = obj.scale.z
                bpy.data.objects.remove(obj, do_unlink=True)
                cobje[0].scale = (PlatformSize, PlatformSize, VerticalPlatformSize)
                obj = cobje[0]
                    
            else:
                for cobj in cobje:
                        
                    cobj.location = obj.location
                    cobj.rotation_euler = obj.rotation_euler
                        
                        
                        

                    bool_mod = obj.modifiers.new(name='Boolean', type='BOOLEAN')
                        
                    bool_mod.object = cobj
                    cobj.select_set(False)
                    bpy.context.view_layer.objects.active = obj
                    obj.select_set(True)
                    bpy.ops.object.modifier_apply(modifier=bool_mod.name)
                    bpy.data.objects.remove(cobj, do_unlink=True)
                    
                obj.name = "temp"
                        
                bpy.ops.mesh.primitive_cube_add(size=1)
                        
                cobj = bpy.context.object
                cobj.scale = (PlatformSize, PlatformSize, VerticalPlatformSize)
                cobj.location = obj.location
                cobj.rotation_euler = obj.rotation_euler
                
                obj.scale = (PlatformSize+0.00001, PlatformSize+0.00001, 40)
                    
                bool_mod = cobj.modifiers.new(name='Boolean', type='BOOLEAN')
                bool_mod.operation = 'DIFFERENCE'
                bool_mod.object = obj
                obj.select_set(False)
                bpy.context.view_layer.objects.active = cobj
                cobj.select_set(True)
                bpy.ops.object.modifier_apply(modifier=bool_mod.name)
                    
                    
                for key in obj.keys():
                    if key != "_RNA_UI":
                        cobj[key] = obj[key]

                    

                    
                    
                    
                bpy.data.objects.remove(obj, do_unlink=True)
                
                obj = cobj
        
        
    if obj["hole"] and PlatformSize >= 1:
            
            
            if create_symbol(obj["hole_shapes"], (round(obj["hole_radius"],3) / 7.2) * max(round(PlatformSize, 3),1)):

                
                cobje = bpy.context.selected_objects
                
                if obj["hole_shapes"] == "ring":
                        
                    cobj = cobje[0]
                    cobj.location = obj.location
                    cobj.rotation_euler = obj.rotation_euler
                        
                    bool_mod = cobje[0].modifiers.new(name='Boolean', type='BOOLEAN')
                    bool_mod.operation = 'DIFFERENCE'
                    bool_mod.object = cobje[1]
                        
                    cobje[1].select_set(False)
                    bpy.context.view_layer.objects.active = cobje[0]
                    cobje[0].select_set(True)
                    bpy.ops.object.modifier_apply(modifier=bool_mod.name)
                    
                    bpy.data.objects.remove(cobje[1], do_unlink=True)
                        
                    
                    bool_mod = obj.modifiers.new(name='Boolean', type='BOOLEAN')
                    bool_mod.operation = 'DIFFERENCE'
                    bool_mod.object = cobje[0]
                        
                    cobje[0].select_set(False)
                    bpy.context.view_layer.objects.active = obj
                    obj.select_set(True)
                    bpy.ops.object.modifier_apply(modifier=bool_mod.name)
                    
                    bpy.data.objects.remove(cobje[0], do_unlink=True)

                        
                else:
                
                    for cobj in cobje:
                        
                        
                        
                        cobj.location = obj.location
                        cobj.rotation_euler = obj.rotation_euler
                        
                        
                        

                        bool_mod = obj.modifiers.new(name='Boolean', type='BOOLEAN')
                        bool_mod.operation = 'DIFFERENCE'

                        bool_mod.object = cobj
                        cobj.select_set(False)
                        bpy.context.view_layer.objects.active = obj
                        obj.select_set(True)
                        bpy.ops.object.modifier_apply(modifier=bool_mod.name)
                        
                        bpy.data.objects.remove(cobj, do_unlink=True)



class ADD_PLATFORM_DIALOG(bpy.types.Operator):
    '''e'''
    bl_label = "Add platform"
    bl_idname = "vuyghu2020.dialog"
    
    Location: bpy.props.FloatVectorProperty(name = "Location", subtype='XYZ')
    Rotation: bpy.props.FloatVectorProperty(name = "Rotation", subtype='XYZ')
    
    PlatformSize: bpy.props.FloatProperty(name = "", precision=3, min = 0.138, max = 40)
    VerticalPlatformSize: bpy.props.FloatProperty(name = "", precision=3, min = 0.5, max = 40)
    
    type: bpy.props.EnumProperty(name = "Material", items=[
            ('grass', 'Grass', "The default"),
            ('snow', 'Snow', "Colder then ice (Will melt in lava)"),
            ('slime', 'Slime', "Sticky (Will make you slower and immune to teleportation)"),
            ('steel', 'Steel', "Steely and hot in lava"),
            ('wood', 'Wood', "Burns easier")
        ])
    conveyor: bpy.props.BoolProperty(name = "Conveyor")
    conveyor_velocity: bpy.props.FloatProperty(name = "", precision=3, min = 0.1, max = 10)
    conveyor_angle: bpy.props.FloatProperty(name = "", precision=3, min = -360, max = 360)
    
    corner_cut: bpy.props.BoolProperty(name = "Corner cut")
    corner_cut_radius: bpy.props.FloatProperty(name = "", precision=3, min = 1, max = 15)
    
    corner_cut_shapes: bpy.props.EnumProperty(name = "Corner cut shape", items=[
            ('none', 'None', "Nouthing changes"),
            ('circle', 'Circle', ""),
            ('square', 'Square', ""),
            ('rectangle', 'Rectangle', ""),
            ('diamond', 'Diamond', ""),
            ('hexagon', 'Hexagon', ""),
            ('plus', 'Plus', ""),
            ('star', 'Star', ""),
            ('heart', 'Heart', ""),
            ('ring', 'Ring', "If scaled it is not the ring will not be displayed as in it wold in game")
        ])
        
    hole: bpy.props.BoolProperty(name = "Hole")
    hole_radius: bpy.props.FloatProperty(name = "", precision=3, min = 1, max = 15)

    hole_shapes: bpy.props.EnumProperty(name = "Hole shape", items=[
            ('none', 'None', "Nouthing changes"),
            ('circle', 'Circle', ""),
            ('square', 'Square', ""),
            ('rectangle', 'Rectangle', ""),
            ('diamond', 'Diamond', ""),
            ('hexagon', 'Hexagon', ""),
            ('plus', 'Plus', ""),
            ('star', 'Star', ""),
            ('heart', 'Heart', ""),
            ('ring', 'Ring', "If scaled it is not the ring will not be displayed as in it wold in game")
        ])

    
    def draw(self, context):
        layout = self.layout
        row = layout.column()
        row.prop(self, "Location")
        row = layout.column()
        row.prop(self, "Rotation")
        row = layout.row()
        row.label(text="PlatformSize (X and Z):")
        row.prop(self, "PlatformSize")
        row = layout.row()
        row.label(text="PlatformSize (Y):")
        row.prop(self, "VerticalPlatformSize")
        row = layout.row()
        row.prop(self, "type")
        row = layout.row()
        row.prop(self, "conveyor")
        if self.conveyor:
            row = layout.row()
            row.label(text="Conveyor velocity:")
            row.prop(self, "conveyor_velocity")
            row = layout.row()
            row.label(text="Conveyor angle:")
            row.prop(self, "conveyor_angle")
        
        row = layout.row()
        row.prop(self, "corner_cut")
        if self.corner_cut:
            row = layout.row()
            row.label(text="Corner cut radius:")
            row.prop(self, "corner_cut_radius")
            row = layout.row()
            row.prop(self, "corner_cut_shapes")
        row = layout.row()
        row.prop(self, "hole")
        if self.hole:
            row = layout.row()
            row.label(text="Hole radius:")
            row.prop(self, "hole_radius")
            row = layout.row()
            row.prop(self, "hole_shapes")

        
    

    
    
    def execute(self, context):
        if not self.create_new:
            obj = bpy.context.object
            bpy.data.objects.remove(obj, do_unlink=True)
        
        add_platform(self.Location, self.Rotation, self.PlatformSize, self.VerticalPlatformSize, self.type, self.conveyor, self.conveyor_velocity, self.conveyor_angle, self.corner_cut, self.corner_cut_radius, self.corner_cut_shapes, self.hole, self.hole_radius, self.hole_shapes)
            

        
        return {'FINISHED'}
            
            
            
        
    
    
    def invoke(self, context, event):
        selected_objects = bpy.context.selected_objects

        if selected_objects:
            objeee = selected_objects[0]
        else:
            objeee = False


        if objeee:
            self.create_new = False
            self.Location = objeee.location
            TEMP = self.Location.y
            self.Location.y = self.Location.z
            self.Location.z = TEMP
            self.Rotation = tuple(math.degrees(rad) for rad in objeee.rotation_euler)
            self.PlatformSize = objeee.scale.x
            self.VerticalPlatformSize = objeee.scale.z
            self.type = objeee.get("type", "grass")
            self.conveyor = objeee.get("conveyor", False)
            self.conveyor_velocity = objeee.get("conveyor_velocity", 0.5)
            self.conveyor_angle = objeee.get("conveyor_angle", -180)
            self.corner_cut = objeee.get("corner_cut", False)
            self.corner_cut_radius = objeee.get("corner_cut_radius", 5.8)
            self.corner_cut_shapes = objeee.get("corner_cut_shapes", "none")
            self.hole = objeee.get("hole", False)
            self.hole_radius = objeee.get("hole_radius", 4)
            self.hole_shapes = objeee.get("hole_shapes", "none")
        else:
            self.create_new = True
            self.Location = (0.0, 0.25, 0.0)
            self.Rotation = (0.0, 0.0, 0.0)
            self.PlatformSize = 6.1
            self.VerticalPlatformSize = 0.5
            self.type = "grass"
            self.conveyor = False
            self.conveyor_velocity = 0.5
            self.conveyor_angle = -180
            self.corner_cut = False
            self.corner_cut_radius = 5.8
            self.corner_cut_shapes = "none"
            self.hole = False
            self.hole_radius = 4
            self.hole_shapes = "none"

            
        return context.window_manager.invoke_props_dialog(self)

"""
class CHANGE_PROPERTYS_SELECTED_BUTTON(bpy.types.Operator):
    bl_label = "Change propertys of selected"
    bl_idname = "vuyghu2020.change_propertys_selected_button"
    
    def execute(self, context):
        bpy.ops.vuyghu2020.change_propertys_dialog('INVOKE_DEFAULT')
        return {'FINISHED'}
"""


class TEMPLATES_BUTTON(bpy.types.Operator):
    bl_label = "Templates"
    bl_idname = "vuyghu2020.templates"


class ADD_PLATFORM_BUTTON(bpy.types.Operator):
    bl_label = "Add / Change platform"
    bl_idname = "vuyghu2020.add_platform_button"
    
    def execute(self, context):
        bpy.ops.vuyghu2020.dialog('INVOKE_DEFAULT')
        return {'FINISHED'}






class COMPILE_SELECTED(bpy.types.Operator):
    bl_label = "Compile selected to clipbord"
    bl_idname = "vuyghu2020.compile_selected"
    
    def execute(self, context):
        
        objs = bpy.context.selected_objects
        e = '''{"RENDER_MODEL", ""}
 [info]
 color 1
 [trigger]
 time 0
 alert_type none
'''
        degre_angel = 1/((math.pi*2)/360) # This line is created whith the help of Observin check his Twitch https://www.twitch.tv/observin_
        for x in objs:
                
            e = e +f'''{{"O_{x.name}", ""}}
 [info]
 color 0
 [general]
 platform_size {max(round(x.scale[0],3),1)}
 platform_vertical_size {round(x.scale[2],3)}
 platform_materials {get_property(x, "type", "grass")}
 [?global.new_platform]
 x {round(x.location[0],3)}
 y {round(x.location[2],3)}
 z {round(x.location[1],3)}
 spawn_in_place true
 x_rotation {round((x.rotation_euler[1] * degre_angel*-1)) % 360}
 y_rotation {round(((x.rotation_euler[2] * degre_angel*-1)*-1)-90) % 360}
 z_rotation {round((x.rotation_euler[0] * degre_angel*-1)*-1) % 360}
 velocity 20
 [trigger]
 relative_time 0
 alert_type none
'''
            if round(x.scale[0],3) < 1:
                
                e = e +f'''{{"S_{x.name}", ""}}
 [info]
 color 0
 [trigger]
 recipients notargeted
 relative_time 0
 alert_type none
 [?platform.corner_cut]
 shapes square
 radius {max(round(round(x.scale[0],3)/1 * 7.2, 3),1)}
'''
            
            if get_property(x, "conveyor", False) or get_property(x, "corner_cut", False) or get_property(x, "hole", False):
                
                e = e +f'''{{"C_{x.name}", ""}}
 [info]
 color 0
 [trigger]
 recipients notargeted
 relative_time 0
 alert_type none
'''
                if get_property(x, "conveyor", False):
                    e = e +f''' [?platform.conveyor]
 angle {get_property(x, "conveyor_angle", -180.0)}
 velocity {get_property(x, "conveyor_velocity", 0.5)}
'''
                if get_property(x, "corner_cut", False):
                    e = e +f''' [?platform.corner_cut]
 shapes {get_property(x, "corner_cut_shapes", "none")}
 radius {get_property(x, "corner_cut_radius", 5.8)}
'''
                if get_property(x, "hole", False):
                    e = e +f''' [?platform.hole]
 shapes {get_property(x, "hole_shapes", "none")}
 radius {get_property(x, "hole_radius", 4)}
'''

        bpy.context.window_manager.clipboard = e
        
        
        
        return {'FINISHED'}
    
    




class TestPanel(bpy.types.Panel):
    bl_label = "Partybots converter panel"
    bl_idname = "TestPanel"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = "Partybots converter"
    
    def draw(self, context):
        leyout = self.layout
        
        row = leyout.row()
        row.operator("vuyghu2020.add_platform_button")
        row = leyout.row()
        row.operator("vuyghu2020.compile_selected")
        row = leyout.row()
        row.label(text = "Made by vuyghu2020")
        
        
        
        
        

        

def register():

    
    
    
    bpy.utils.register_class(TestPanel)
    bpy.utils.register_class(ADD_PLATFORM_DIALOG)
    bpy.utils.register_class(ADD_PLATFORM_BUTTON)
    bpy.utils.register_class(COMPILE_SELECTED)
    
    

    
    
    
    
    
def unregister():
    

    
    bpy.utils.unregister_class(TestPanel)
    bpy.utils.unregister_class(ADD_PLATFORM_DIALOG)
    bpy.utils.unregister_class(ADD_PLATFORM_BUTTON)
    bpy.utils.unregister_class(COMPILE_SELECTED)
    

    
    
    
if __name__ == "__main__":
    register()
    


